'From Squeak 2.4b of April 23, 1999 on 12 July 1999 at 2:13:31 am'!
SimpleMorphicWrapper subclass: #MatrixMorphicWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!
MatrixMorphicWrapper subclass: #ReducerMorphicWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!
SimpleMorphicWrapper subclass: #TupleMorphicWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!

!Matrix methodsFor: 'accessing' stamp: 'LC 2/14/1999 16:47'!
at: ijPoint put: scalar
	| answer |
	answer _ (self row: ijPoint x) at: ijPoint y put: scalar.
	self updateMorph.
	^ answer! !

!Matrix methodsFor: 'accessing' stamp: 'LC 2/14/1999 16:51'!
atRow: i put: aTuple
	| answer |
	answer _ rows at: i put: aTuple.
	self updateMorph.
	^ answer! !

!Matrix methodsFor: 'morphic wrappers' stamp: 'LC 3/4/1999 17:22'!
morphicWrapperClass
	^ Smalltalk at: #MatrixMorphicWrapper! !


!MatrixMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/12/1999 02:12'!
tile: entry 
	| answer |
	answer _ entry printString newTileMorphRepresentative.
	answer borderWidth: 0;
	 color: Color transparent;
	 lock.
	^ answer! !

!MatrixMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/10/1999 22:12'!
updateContents
	strings removeAllMorphs.
	self object columnsDo: [:col | strings addMorphBack: (self wrapColumn: col)].
	self bounds: strings fullBounds
! !

!MatrixMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/12/1999 00:30'!
wrapColumn: aColumn 
	| wrap |
	wrap _ AlignmentMorph newColumn.
	wrap hResizing: #shrinkWrap;
	 vResizing: #shrinkWrap;
	 centering: #center;
	 inset: 0;
	 color: Color transparent.
	aColumn do: [:entry | wrap addMorphBack: (self tile: entry)].
	^ wrap! !

!MatrixMorphicWrapper methodsFor: 'initialization' stamp: 'LC 7/12/1999 00:39'!
initialize
	super initialize.
	strings orientation: #horizontal;
	 borderWidth: 1;
	 borderColor: Color gray;
	 color: (Color r: 0.8 g: 1.0 b: 0.8)! !


!MatrixMorphicWrapper class methodsFor: 'instance creation' stamp: 'LC 3/4/1999 17:24'!
canWrap: anObject 
	^ (anObject isKindOf: (Smalltalk at: #Matrix))
		or: [anObject isKindOf: (Smalltalk at: #MatrixReducer)]! !


!MatrixReducer methodsFor: 'accessing' stamp: 'LC 7/10/1999 21:25'!
matrix: aMatrix extension: extMatrix
	| scalars |
	matrix _ aMatrix.
	extension _ ((extMatrix isKindOf: Matrix) or: [extMatrix isNil])
		ifTrue: [extMatrix]
		ifFalse:
			[Matrix
				indexedBy: (aMatrix rowIndexes cartesian: (1 to: 1))
				fromBlock: [:pair | extMatrix at: pair x]
				scalars: aMatrix scalars].
	columns _ ReadStream on: aMatrix columnIndexes asArray.
	inverse _ aMatrix class
		idIndexedBy: aMatrix rowIndexes asArray
		scalars: (scalars _ aMatrix scalars).
	pivots _ OrderedCollection new.
	zero _ scalars zero.
	det _ scalars unit! !

!MatrixReducer methodsFor: 'moprhic wrappers' stamp: 'LC 7/6/1999 11:43'!
morphicWrapperClass
	^ Smalltalk at: #ReducerMorphicWrapper ifAbsent: [super morphicWrapperClass]! !


!ReducerMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/6/1999 11:43'!
checkObject
	| matrixClass |
	matrixClass _ Smalltalk at: #SimpleMatrix ifAbsent: [^ self].
	object isNil
		ifTrue: [object _ MatrixReducer input: (matrixClass id: 3)]
		ifFalse: [object triangulated isNil ifTrue: [object matrix: (matrixClass id: 3)]]! !

!ReducerMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/12/1999 00:26'!
updateContents
	| upper lower w |
	strings removeAllMorphs.
	self checkObject.
	self object leftInverse columnsDo: [:col | strings addMorphBack: (w _ self wrapColumn: col)].
	upper _ w topRight.
	lower _ w bottomRight - (0 @ 2).
	strings addMorphBack: (PolygonMorph
			vertices: (Array with: upper with: lower)
			color: Color gray
			borderWidth: 1
			borderColor: Color gray).
	self object triangulated columnsDo: [:col | strings addMorphBack: (self wrapColumn: col)].
	self bounds: strings fullBounds! !

!ReducerMorphicWrapper methodsFor: 'initialization' stamp: 'LC 7/12/1999 00:26'!
initialize
	super initialize.
	strings orientation: #horizontal;
	 hResizing: #shrinkWrap;
	 vResizing: #shrinkWrap;
	 inset: 0;
	 color: Color lightCyan! !


!ReducerMorphicWrapper class methodsFor: 'instance creation' stamp: 'VM 7/5/1999 11:37'!
canWrap: anObject 
	^ anObject isKindOf: (Smalltalk at: #MatrixReducer)! !


!SimpleTuple methodsFor: 'moprhic wrappers' stamp: 'LC 7/10/1999 22:15'!
morphicWrapperClass
	^ Smalltalk at: #TupleMorphicWrapper ifAbsent: [super morphicWrapperClass]! !


!SimpleTuple class methodsFor: 'instance creation' stamp: 'LC 7/10/1999 22:14'!
canWrap: anObject 
	^ anObject isKindOf: (Smalltalk at: #Tuple)
! !


!TupleMorphicWrapper methodsFor: 'initialization' stamp: 'LC 7/10/1999 22:09'!
initialize
	super initialize.
	strings orientation: #horizontal;
	 centering: #center;
	 borderWidth: 1;
	 borderColor: Color gray! !

!TupleMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/10/1999 22:52'!
tile: entry 
	| answer |
	answer _ entry printString newTileMorphRepresentative.
	answer borderWidth: 0;
	 color: Color lightRed.
	^ answer! !

!TupleMorphicWrapper methodsFor: 'updating' stamp: 'LC 7/10/1999 22:53'!
updateContents
	strings removeAllMorphs.
	object isNil ifTrue: [self object: (SimpleTuple e: 1 dim: 3)].
	object do: [:entry | strings addMorphBack: (self tile: entry)].
	self bounds: strings fullBounds! !


!TupleMorphicWrapper class methodsFor: 'instance creation' stamp: 'LC 7/11/1999 11:11'!
canWrap: anObject
	^ anObject isKindOf: Tuple! !


ReducerMorphicWrapper removeSelector: #color!
ReducerMorphicWrapper removeSelector: #tile:!
